package api

import (
	"github.com/gin-gonic/gin"

	"git.nemunai.re/nemunaire/reveil/config"
)

func DeclareRoutes(router *gin.Engine, cfg *config.Config) {
	apiRoutes := router.Group("/api")

	declareActionsRoutes(cfg, apiRoutes)
	declareAlarmsRoutes(cfg, apiRoutes)
	declareGongsRoutes(cfg, apiRoutes)
	declareHistoryRoutes(cfg, apiRoutes)
	declareQuotesRoutes(cfg, apiRoutes)
	declareRoutinesRoutes(cfg, apiRoutes)
	declareTracksRoutes(cfg, apiRoutes)
	declareSettingsRoutes(cfg, apiRoutes)
}
